MP4Client(1)

NAME

MP4Client - GPAC MPEG-4 command-line Player

SYNOPSIS

MP4Client [options] [file]

DESCRIPTION

MP4Client is GPAC command-line player. It supports all GPAC playback features (2D and 3D support, local playback, RTP streaming, HTTP faststart, many audio and video codecs ...). MP4Client also supports visual extraction to BMP, RAW or AVI (no compression, no audio).

STARTUP OPTIONS

-c file
    specifies config file to use. Default config file is located in user home directory and created if not found.

-rti file
    logs run-time information to file. Information logged is: FPS, CPU, Memory usage.

-quiet
    removes script message, buffering and downloading status.

-strict-error
    exits after the first error is reported.

-log-file FILE
    specifies where to write logs. Default is stdout. Same as -lf.

-logs TOOLS
    sets log tools and levels, formatted as a ':'-separated list of toolX[:toolZ]@level. By default all errors are logged. level can be one of quiet, error, warning, info or debug. tool can be:
    core: libgpac core
    coding: bitstream formats (audio, video, scene)
    container: container formats (ISO File, MPEG-2 TS, AVI, ...)
    network: network data exept RTP trafic
    rtp: rtp trafic
    author: authoring tools (hint, import, export)
    sync: terminal sync layer
    codec: terminal codec messages
    parser: scene parsers (svg, xmt, bt) and other
    media: terminal media object management
    scene: scene graph and scene manager
    script: scripting engine messages
    interact: interaction engine (events, scripts, etc)
    smil: SMIL timing engine
    compose: composition engine (2D, 3D, etc)
    mmio: Audio/Video HW I/O management
    rti: various run-time stats
    cache: HTTP cache subsystem
    audio: Audio renderer and mixers
    mem: GPAC memory tracker
    module: GPAC modules debugging
    mutex: mutex
    none: no tool logged
    all: all tools logged - other tools can be specified afterwards.

PLAYBACK OPTIONS
A file can be controled during playback by typing one of the following key at prompt.

o   connects to a new URL entered at prompt by user.

r   restarts the current presentation

p   plays/pauses the current presentation

s   step one frame ahead in the current presentation

z   seek into presentation. Seek percentage is entered at prompt

t   prints current timing of the main timeline of the presentation

w   prints world info of the current presentation

v   prints list of all GF_ObjectDescriptor used in current presentation.

i   prints information of a given OD. Object ID is entered at prompt.

b   prints all objects timing and buffering info.

m   prints all objects buffering and memory info.

d   dumps current presentation scene graph to file or stdout.

k   Turns stress mode on/off.

n   Changes current navigation mode if possible/allowed. When a Layer3D is selected, sets layer3D navigation if allowed.

x   Reset to last active viewpoint. When a layer3D is selected, resets layer3D viewpoint.

2   Reload MPEG-4 Client with GPAC 2D Renderer.

3   Reload MPEG-4 Client with GPAC 3D Renderer.

4   forces 4/3 Aspect Ratio.

5   forces 16/9 Aspect Ratio.

6   forces no aspect ratio (always fill screen).

7   forces original Aspect Ratio (default mode).

l   prints the list of available plugins.

c   prints some GPAC configuration info.

q   quits the application.

C   enables streaming cache.

S   stops streaming cache and record it.

A   stops streaming cache and discard it.

h   prints list of available commands.

WINDOW SHORTCUTS
When MP4Client window has the focus, the following shortcuts are available

Alt + right
    Seeks 5% ahead from current time.

Alt + left
    Seeks 5% before the current time

Alt + up
    Increases volume by 5%

Alt + down
    Decreases volume by 5%

HOME
    Resets navigation to last bound viewpoint/viewport

4, 5, 6, 7
    Same as non-window values

ESCAPE , alt+return, doubleclick
    Toggles fullscreen on/off.

ctrl + 'f'
    Prints current rendering framerate.

ctrl + 'R'
    Sends a redraw message (complete scene state recompute).

ctrl + 'P'
    Play/Pause.

ctrl + 'S'
    Step one frame ahead.

CONFIGURATION FILE
When launched for the first time, MP4Client will ask for a font directory and a cache directory.

Font Directory
    Indicates the absolute path to a directory containing a TrueType font repository. In case this directory is not specified or does not contain valid TrueType fonts, text will be disabled.

Cache Directory
    Indicates the absolute path to a directory with write access to store files retrieved through HTTP downloads. In case this directory is not specified or has no write access HTTP downloads won't work.

NAVIGATION
Navigation with MP4Client depends on the renderer type (2D or 3D) and also on content - some content may disable user selectable navigation.

Walk & Fly modes
    Mouse: Horizontal move: Horizontal pan - Vertical move: Z-translate - Vertical move+CTRL or Wheel: Vertical pan - Right Click (Walk mode only): Jump Keys: left/right: Horizontal pan - left/right+CTRL: Horizontal translate - up/down: Z-translate - up/down+CTRL: Vertical pan

Pan mode
    Mouse: Horizontal move: Horizontal pan - Vertical move: Vertical pan - Vertical move+CTRL or Wheel: Z-translate Keys: left/right: Horizontal pan - left/right+CTRL: Horizontal translate - up/down: Vertical pan - up/down+CTRL: Z-translate

Slide mode
    Mouse: Horizontal move: Horizontal translate - Vertical move: Vertical translate - Vertical move+CTRL or Wheel: Z-translate Keys: left/right: Horizontal translate - left/right+CTRL: Horizontal pan - up/down: Vertical translate - up/down+CTRL: Z-translate

Examine & Orbit mode
    Mouse: Horizontal move: Y-Axis rotate - Horizontal move+CTRL: No move - Vertical move: X-Axis rotate - Vertical move+CTRL or Wheel: Z-translate Keys: left/right: Y-Axis rotate - left/right+CTRL: Horizontal translate - up/down: X-Axis rotate - up/down+CTRL: Y-translate

Game mode (press END to escape)
    Mouse: Horizontal move: H pan - Vertical move: Vertical pan Keys: left/right: Horizontal translate - up/down: Z-translate

All 3D modes
    CTRL+PGUP/PGDOWN will zoom in/out camera (field of view)

Slide Mode in 2D
    Mouse: Horizontal move: Horizontal translate - Vertical move: Vertical translate - V move+CTRL: zoom Keys: left/right: Horizontal translate - up/down: Vertical translate - up/down+CTRL: zoom

Examine Mode in 2D (3D renderer only)
    Mouse: Horizontal move: Y-Axis rotate - Vertical move: X-Axis rotate Keys: left/right: Y-Axis rotate - up/down: X-Axis rotate

SHIFT
    Speeds up movement

VISUAL EXTRACTION OPTIONS
When used to dump a visual presentation, the client is no longer interactive. All GPAC features are supported during capture, except audio-related ones. The following options can be passed at prompt:

-bmp [times]
    dumps the specified frames to BMP format. If no time is specified, capture is made at t=0s. time is given in millisecond, as an SMPTE time code or as HH:MM:SS:MS time code. You may specify several frame times by using a dash-separated list of times (eg, '0-10-15').

-raw [times]
    dumps the specified frames to RAW format. If no time is specified, cpature is made at t=0s.

-avi start:end
    dumps the specified segment to uncompressed AVI format.

-fps rate
    specifies frame rate for AVI dumping. Default frame rate is 25.0.

-size WxH
    specifies frame size for dumping. Default frame size is the scene size.

-fill
    uses fill aspect ratio. By default, the scene aspect ratio is preserved when dumping.

-show
    show window while dumping the content. By default, the window is hidden during capture.

-2d forces usage of 2D renderer. By default, MP4Client uses the renderer indicated in GPAC configuration file.

-3d forces usage of 3D renderer. By default, MP4Client uses the renderer indicated in GPAC configuration file.

-quiet
    removes script message, buffering and downloading status.

FILES

GPAC Configuration File: ~/.gpacrc

AUTHORS

Jean Le Feuvre <jeanlf@users.sourceforge.net> - GPAC (c) 2000-2005 - ENST 2005-200X

SEE ALSO

GPAC(1), MP4Box(1)